/**
* Vmbackup App
* There are different ways implementing an App
*/
var VmBackupApp = VmBackupApp || {};  //Define App namespace, if you want.
/**
*Constructor UNAS App
*/
VmBackupApp.App = function () {
    this.id = 'VmbackupApp';
    this.name = 'VMware EXSi Backup';
    this.version = '6.0.8';
    this.active = false;
    this.menuIcon = '/apps/vmbackup/images/logo.png?v=6.0.8&';
    this.shortcutIcon = '/apps/vmbackup/images/logo.png?v=6.0.8&';
    this.entryUrl = '/apps/vmbackup/vmbackup.html?v=6.0.8&';
    var self = this;
    this.VmBackupAppWindow = function () { //create app window
        if(UNAS.CheckAppState('Vmbackup')){
            return false;
        }
        self.window=new MUI.Window({
            id: 'VmBackupAppWindow',
            title: UNAS._('Vmbackup'),
            icon: '/apps/vmbackup/images/logo_small.png?v=6.0.8&',
            width: 1050,
            height: 500,
            maximizable: false,
            resizable: true,
            scrollbars: false,
            resizeLimit: { 'x': [960, 2000], 'y': [450, 1500] },
            loadMethod: 'xhr',
            contentURL: '/apps/vmbackup/vmbackup.html',
            require: {  css: [
              '/apps/vmbackup/css/vmbackup.css?v=6.0.8&',
              '/apps/vmbackup/css/backupsettings.css?v=6.0.8&',
              '/apps/vmbackup/css/alert.css?v=6.0.8&'
            ] },
            onBeforeBuild: function(){UNAS.SetAppOpenedWindow("Vmbackup",'VmBackupAppWindow')},
            onClose:function(){
                clearTimeout(vmbackup_Running);
                clearTimeout(vmbackup_progress_time);
            }
        });
    };
    this.VmBackupAppUninstall = function (){
        UNAS.RemoveDesktopShortcut('Vmbackup');
        UNAS.RemoveMenu('Vmbackup');
        UNAS.RemoveAppFromGroups('Vmbackup', 'ControlPanel');
        UNAS.RemoveAppFromGroups('Vmbackup', 'Help');
        UNAS.RemoveAppFromApps('Vmbackup');
    }
    new UNAS.Menu('UNAS_App_Accessories_Menu', this.name, this.menuIcon, 'Vmbackup', '', this.VmBackupAppWindow);
    //new UNAS.DesktopShortcut(this.name, this.shortcutIcon, 'Vmbackup', this.VmBackupAppWindow);
    // new UNAS.RegisterToAppGroup(this.name, 'ControlPanel', {'Type' : 'Storage', 'Location' : 3, "Icon": this.shortcutIcon, "Url": this.entryUrl},{});
    //new UNAS.RegisterToAppGroup(this.name, 'Help', {'Type' : 'Storage', 'Location' : 3, "Icon": this.shortcutIcon, "Url": this.entryHelpUrl},{});
    var OnChangeLanguage = function (e) {
        UNAS.SetMenuTitle('Vmbackup', UNAS._('Vmbackup')); //translate menu
        //UNAS.SetShortcutTitle('Vmbackup', UNAS._('Vmbackup')); //translate shortcut
        if (typeof self.window !== 'undefined') {
            //need to translate the window title, menu and shortcut
            UNAS.SetWindowTitle('VmBackupAppWindow', UNAS._('Vmbackup'));
        }
    }
    UNAS.LoadTranslation('/apps/vmbackup/languages/Translation?v='+this.version, OnChangeLanguage);
    UNAS.Event.addEvent('ChangeLanguage', OnChangeLanguage);
    UNAS.CreateApp(this.name,this.shortcutIcon,this.VmBackupAppWindow,this.VmBackupAppUninstall);
};
new VmBackupApp.App(); //Create app
