var vmbackupLogPage = {
  index: 1,
  amount: 10,
  pageCount: 1
}

window.vmbackup_progress_time = null;
window.vmbackup_Running = null;
var curhostdom = null;

var backuperrmsg = {
  '9969': 'Snapshot creation failed',
  '9916': 'Insufficient disk space'
}

function vmbackupLoadHosts() {
  vmbackupLoadingShow();
  return new Promise(function(resolve, reject) {
    jQuery.ajax({
      url: '/apps/vmbackup/includes/index.php',
      type: 'POST',
      data: JSON.encode({
        cmd: 'vmbackup_host_alload',
        token: UToken
      }),
      dataType: 'json',
      contentType: 'application/json',
      success: function(data) {
        // console.log(data);
        resolve(data);
        jQuery('#jv-vmHost').empty();
        jQuery('#jv-vmbackupfolderhost').empty();
        if (data.err == 0) {
          var info = data.results.records || {};

          if (info != null && JSON.stringify(info) != "{}") {
            var hosts = info.hosts || [];
            var vcs = info.vcs || [];

            for (var v in info) {
              if (info.hasOwnProperty(v)) {
                jQuery('#jv-vmbackup_vtabContent_title').css('display', 'flex');

                switch (v) {
                  case 'hosts':
                    if (hosts.length) {
                      var hostdom = vmbackupTemplateAppend('#jv-vmHost', 'jvt-vc-host', 'jvt-vc-host' + v);
                      hostdom.find('.h-title').text(v);
                      for (var i = 0; i < hosts.length; i++) {
                        var hostsdata = hosts[i];
                        var vmhost = hostdom.find('.vmHost');
                        var vmipdom = vmbackupTemplateAppend(vmhost, 'jvt-vmipitem', 'jvt-vmipitem' + v + i);
                        vmipdom.find('.ipinfo').data('vmipinfo', hostsdata);
                        vmipdom.find('.vm-ipname').text(hostsdata.host + ':' + hostsdata.port);
                        vmipdom.find('.drop-down').data('vmipinfo', hostsdata);

                        vmipdom.find('.drop-down').addClass('closeitem');
                        if (i == 0) {
                          jQuery('#jv-backupdir').text(hostsdata.backupdir);
                        }

                        vmipdom.find('.drop-down').on('click', function(e) {
                          e.stopPropagation();
                          var parentnode = jQuery(this).parent().parent();

                          if (jQuery(this).hasClass('openitem')) {
                            jQuery(this).removeClass('openitem').addClass('closeitem');
                            parentnode.find('.jvc-vmiphost').hide();
                          } else {
                            parentnode.find('.jvc-vmiphost').show();
                            // jQuery('#jv-vmHost .drop-down').each(function(i, e){
                            //   jQuery(e).addClass('closeitem').removeClass('openitem')
                            // })
                            jQuery(this).removeClass('closeitem').addClass('openitem');

                            // parentnode.siblings().find('.jvc-vmiphost').hide();

                            vmbackup_vm_loadby(jQuery(this).data('vmipinfo'), jQuery(this).parent().parent());
                          }

                        })

                        vmipdom.find('.ipinfo').on('click', function(e) {
                          jQuery('#jv-backup-setting').unbind();
                          jQuery('#jv-backup-setting').attr('onclick', 'backupsettings()');
                          jQuery('.vmipinfoitem,.ipinfo').removeClass('curselectvm');
                          jQuery(this).addClass('curselectvm');
                          vmbackupLoadHostVMs(jQuery(this).data('vmipinfo'), jQuery(this).parent().parent());
                          clearTimeout(vmbackup_progress_time);
                          clearTimeout(vmbackup_Running);
                        })
                      }
                    }
                    break;
                  case 'vcs':

                    for (var j = 0; j < vcs.length; j++) {
                      var vcdata = vcs[j];
                      var vcdom = vmbackupTemplateAppend('#jv-vmHost', 'jvt-vc-host', 'jvt-vc-host' + v + j);
                      vcdom.find('.h-title').text('vCenter: ' + (vcs[j].host || '--') + ':' + vcs[j].port);
                      vcdom.find('.ipinfotile').addClass('vcinfo');
                      vcdom.find('.delete').data('vcinfo', vcdata);
                      vcdom.find('.delete').show().on('click', function(){
                        var vcdata_delete = jQuery(this).data('vcinfo');
                        var confirmremovevcWindow = new MUI.Modal({
                          id: 'jv-confirmremovevcWindow',
                          title: UNAS._('Delete')  + ' vCenter',
                          modal: true,
                          modalOverlayClose: false,
                          width: 400,
                          height: 210,
                          data : vcdata_delete,
                          contentURL: '/apps/vmbackup/removevc.html?v=6.0.8'
                        });
                        confirmremovevcWindow.callBack = function(){
                          vmbackup_vc_remove(vcdata_delete);
                        }

                      });

                      vmbackup_vc_host_alload(vcdata, vcdom);

                    }

                    break;
                  default:

                }

              }

            }

            if (jQuery('#jv-vmhost .ipinfo').length) {
              setTimeout(function() {
                jQuery('#jv-vmhost .ipinfo').eq(0).click();
                // vmipdom.find('.vmHostitem').eq(0).find('.drop-down').click();
              }, 200);
            }

          } else {
            jQuery('#jv-vmbackup_vtabContent_title').hide();
          }

        } else {
          jQuery('#jv-vmbackup_vtabContent_title').hide();
        }

      },
      error: function(XMLHttpRequest, textStatus, errorThrown) {
        alert(textStatus);
      },
      complete: function(xhr, status) {
        vmbackupLoadingHide();
      }
    });
  })
}

function vmbackupLoadHostVMs(hostinfo, target) {
  jQuery('#jv-VMname').hide();
  jQuery('#jv-removeHostcontent').show();
  if (!hostinfo.hstno) {
    hostinfo['btntext'] = 'Connect';
    jQuery('#jv-vmbackupfolderhost').empty();
    jQuery('#jv-hostName').text(hostinfo.host).data('curhostinfo', hostinfo);
    jQuery('#jv-removeHost').data('hostinfo', hostinfo);

    vmbackupAddVMHost(hostinfo);
    return;
  }
  curhostdom = target;
  vmbackupLoadingShow();
  jQuery.ajax({
    url: '/apps/vmbackup/includes/index.php',
    type: 'POST',
    data: JSON.encode({
      cmd: 'vmbackup_hostvm_loadby',
      token: UToken,
      params: {
        hstno: +hostinfo.hstno
      }
    }),
    dataType: 'json',
    contentType: 'application/json',
    success: function(data) {
      jQuery('#jv-hostName').text(hostinfo.host).data('curhostinfo', hostinfo);
      jQuery('#jv-removeHost').data('hostinfo', hostinfo);
      // target.find('.jvc-vmiphost').empty();
      jQuery('#jv-vmbackupfolderhost').empty();
      if (data.err == 0) {
        jQuery('#jv-esxinotready').attr('style', 'display:none');
        var results = data.results || {};
        refreshVmlist(results, hostinfo);
      } else if (data.err == 9999) {
        jQuery('#jv-esxinotready').attr('style', 'display:block');
        if (typeof(data.err_line) != 'undefined') {
          jQuery('#jv-esxinotready_warning').attr('title', data.err_line);
        } else {
          jQuery('#jv-esxinotready_warning').attr('title', "");
        }
      }
      vmbackupTranslator('jv-vmbackupfolderhost');
    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      alert(textStatus);
    },
    complete: function(xhr, status) {
      vmbackupLoadingHide();
    }
  });
}

function vmbackup_vm_loadby(hostinfo, target) {
  vmbackupLoadingShow();
  jQuery.ajax({
    url: '/apps/vmbackup/includes/index.php',
    type: 'POST',
    data: JSON.encode({
      cmd: 'vmbackup_vm_loadby',
      token: UToken,
      params: {
        hstno: +hostinfo.hstno
      }
    }),
    dataType: 'json',
    contentType: 'application/json',
    success: function(data) {
      // console.log(data);
      target.find('.jvc-vmiphost').empty();
      if (data.err == 0) {
        var results = data.results || {};
        var records = results.records || [];
        for (var i = 0; i < records.length; i++) {
          var hostvminfo = records[i];
          var vmdom = vmbackupTemplateAppend(target.find('.jvc-vmiphost'), 'jvt-vmipinfoitem', 'jvt-vmipinfoitem' + setDomID());
          vmdom.find('span').html('VM: ' + hostvminfo.vmname).attr('title', hostvminfo.vmname);
          vmdom.data('vminfo', hostvminfo).attr('vmname', hostvminfo.vmname);
          vmdom.on('click', function() {
            if (jQuery(this).hasClass('curselectvm')) {
              return;
            }
            var vminfo = jQuery(this).data('vminfo');

            jQuery('#jv-backup-setting').attr('onclick', '');
            jQuery('#jv-backup-setting').unbind();
            jQuery('#jv-backup-setting').on('click', function(){
              vm_version_settings(hostinfo, vminfo);
            })

            vmbackupLoadingShow();
            jQuery('.vmipinfoitem,.ipinfo').removeClass('curselectvm');
            jQuery(this).addClass('curselectvm');
            clearTimeout(vmbackup_progress_time);
            clearTimeout(vmbackup_Running);
            vmbackupLoadVMDetail(jQuery(this).data('vminfo')).then(function(res) {
              vmbackup_progress();
            });
          })
        }
      }

    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      alert(textStatus);
    },
    complete: function(xhr, status) {
      vmbackupLoadingHide();
    }
  });
}

function vmbackup_vc_remove(vcinfo){
  vmbackupLoadingShow();
  jQuery.ajax({
    url: '/apps/vmbackup/includes/index.php',
    type: 'POST',
    data: JSON.encode({
      cmd: 'vmbackup_vc_remove',
      token: UToken,
      params: {
        vc: +vcinfo.vcno
      }
    }),
    dataType: 'json',
    contentType: 'application/json',
    success: function(data) {

      if (data.err == 0) {
        vmbackupLoadHosts();
      }

    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      alert(textStatus);
    },
    complete: function(xhr, status) {
      vmbackupLoadingHide();
    }
  });
}
function vmbackup_vc_host_alload(vcinfo, target) {
  vmbackupLoadingShow();
  jQuery.ajax({
    url: '/apps/vmbackup/includes/index.php',
    type: 'POST',
    data: JSON.encode({
      cmd: 'vmbackup_vc_host_alload',
      token: UToken,
      params: {
        vc: +vcinfo.vcno
      }
    }),
    dataType: 'json',
    contentType: 'application/json',
    success: function(data) {
      target.find('.jvc-vciphost').empty();
      if (data.err == 0) {
        var info = data.results || [];
        var vmhost = target.find('.vmHost');

        for (var i = 0; i < info.length; i++) {
          var vcsdata = info[i];
          var vcipdom = vmbackupTemplateAppend(vmhost, 'jvt-vmipitem', 'jvt-vmipitemvcs' + i);

          vcipdom.find('.ipinfo').data('vcipinfo', vcsdata);
          vcipdom.find('.drop-down').data('vcinfo', vcsdata);
          vcipdom.find('.vm-ipname').text((vcsdata.host || '--') + ':' + vcsdata.port);

          vcipdom.find('.drop-down').addClass('closeitem');

          vcipdom.find('.drop-down').on('click', function(e) {
            e.stopPropagation();
            var parentnode = jQuery(this).parent().parent();
            if (jQuery(this).hasClass('openitem')) {
              jQuery(this).removeClass('openitem').addClass('closeitem');
              parentnode.find('.jvc-vmiphost').hide();
            } else {
              parentnode.find('.jvc-vmiphost').show();
              // jQuery('#jv-vmHost .drop-down').each(function(i, e){
              //   jQuery(e).addClass('closeitem').removeClass('openitem')
              // })
              jQuery(this).removeClass('closeitem').addClass('openitem');
              // parentnode.siblings().find('.jvc-vmiphost').hide();
              vmbackup_vm_loadby(jQuery(this).data('vcinfo'), jQuery(this).parent().parent());
            }

          })

          vcipdom.find('.ipinfo').on('click', function(e) {
            jQuery('#jv-backup-setting').unbind();
            jQuery('#jv-backup-setting').attr('onclick', 'backupsettings()');
            jQuery('.vmipinfoitem,.ipinfo').removeClass('curselectvm');
            jQuery(this).addClass('curselectvm');
            vmbackupLoadHostVMs(jQuery(this).data('vcipinfo'), jQuery(this).parent().parent());
            clearTimeout(vmbackup_progress_time);
            clearTimeout(vmbackup_Running);
          })

        }
      }

    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      alert(textStatus);
    },
    complete: function(xhr, status) {
      vmbackupLoadingHide();
    }
  });
}


function refreshVmlist(records, hostinfo) {

  for (var i in records) {
    if (records.hasOwnProperty(i)) {
      var hostvminfo = records[i];
      var folderhostdom = vmbackupTemplateAppend('#jv-vmbackupfolderhost', 'jvt-folder_vm', 'jvt-folder_vm' + setDomID());
      folderhostdom.find('.folderName').html(hostvminfo.vmname).attr('title', hostvminfo.vmname);
      folderhostdom.find('.jvc-schedule').data('vminfo', hostvminfo);
      folderhostdom.find('.jvc-manually').data('vminfo', hostvminfo);
      folderhostdom.find('.jvc-setting').data('vminfo', hostvminfo);
      folderhostdom.find('.jvc-manually').on('click', function() {
        var manuallyvminfo = jQuery(this).data('vminfo');
        // curhostdom
        var confirmBackupWindow = new MUI.Modal({
          id: 'jv-confirmBackupWindow',
          title: UNAS._('##$@vmbackup@$##Backup Now##$@vmbackup@$##'),
          modal: true,
          modalOverlayClose: false,
          width: 400,
          height: 210,
          contentURL: '/apps/vmbackup/backup_confirm.html?v=6.0.8'
        });
        confirmBackupWindow.callBack = function() {
          vmbackup_backup_create(hostinfo, manuallyvminfo).then(function(res) {
            if (res.err == 0) {
              vmbackup_vm_loadby(jQuery('#jv-removeHost').data('hostinfo'), curhostdom);
            }
          });
        };

      })
      folderhostdom.find('.jvc-schedule').on('click', function() {
        var schedulevminfo = jQuery(this).data('vminfo');
        vmbackupplan(schedulevminfo);
      })
      folderhostdom.find('.jvc-setting').on('click', function() {
        var vminfo = jQuery(this).data('vminfo');
        vm_version_settings(hostinfo, vminfo);
      })
    }
  }

}

//
function vm_version_settings(host, vm){
  var VmBackupSettingWindow = new MUI.Modal({
    id: 'jv-VmBackupSettingWindow',
    title: UNAS._(vm.vmname + ' ##$@vmbackup@$##Backup Setting##$@vmbackup@$##'),
    modal: true,
    modalOverlayClose: false,
    width: 650,
    height: 370,
    contentURL: '/apps/vmbackup/vm_version_settings.html?v=6.0.8&hstno=' + host.hstno + '&vmname=' + vm.vmname
  });
}
// 还原到新虚拟机
function restoreToNewVM(vminfo, backupinfo) {
  var e = window.event || arguments.callee.caller.arguments[0];
  // var vminfo = jQuery(e.target).data('vminfo');

  var addVmWindow = new MUI.Modal({
    id: 'jv-addVmWindow',
    title: UNAS._('##$@vmbackup@$##Restore to a new VM##$@vmbackup@$##'),
    modal: true,
    modalOverlayClose: false,
    width: 500,
    height: 250,
    vminfo: vminfo,
    backupinfo: backupinfo,
    contentURL: '/apps/vmbackup/addvm.html?v=6.0.8&'
  });
  addVmWindow.callBack = function() {
    vmbackupLoadingShow();
    vmbackupLoadHosts();
  };

}
// Vm 备份详情
function vmbackupLoadVMDetail(hostVminfo) {
  // vmbackupLoadingShow();
  jQuery('#jv-VMname').show().find('.folderName').text(hostVminfo.vm);
  jQuery('#jv-removeHostcontent').hide();
  return new Promise(function(resolve, reject) {
    jQuery.ajax({
      url: '/apps/vmbackup/includes/index.php',
      type: 'POST',
      data: JSON.encode({
        cmd: 'vmbackup_backup_loadby',
        token: UToken,
        params: {
          vmno: hostVminfo.vmno
        }
      }),
      dataType: 'json',
      contentType: 'application/json',
      success: function(data) {
        // console.log(data);
        jQuery('#jv-vmbackupfolderhost').empty();
        var unasTable = vmbackupTemplateAppend('#jv-vmbackupfolderhost', 'jvt-unas_table', 'jvt-unas_table-' + setDomID());
        // unasTable.find('input').attr('id', 'vmb_backup_select_all' + hostVminfo.vmname);
        // unasTable.find('label').attr('for', 'vmb_backup_select_all' + hostVminfo.vmname);
        if (data.err == 0) {
          var records = data.results.records || [];
          var is_running = 0;
          for (var i = 0; i < records.length; i++) {
            var info = records[i];
            var trdom = vmbackupTemplateAppend(unasTable.find('.jvc-unas_table_content'), 'jvt-tr', 'jvt-tr-' + i);
            trdom.find('input').attr('id', 'vmb_select-' + i);
            trdom.find('label').attr('for', 'vmb_select-' + i);
            trdom.find('.time').text(info.starttime.substr(0, 19));
            if (+info.jobbytes) {
              trdom.find('.size').text(UNAS.getReadableSizeString(+info.jobbytes || 0));
            } else {
              trdom.find('.size').text('0KB');
            }

            trdom.data('backupinfo', info);
            trdom.find('.delete').data('backupinfo', info);
            trdom.find('.revert').data('backupinfo', info);
            trdom.find('.restore').data('backupinfo', info);
            trdom.find('.delete').on('click', function() {
              var that = jQuery(this);
              var RemoveBackupWindow = new MUI.Modal({
                id: 'jv-RemoveBackupWindow',
                title: UNAS._('##$@vmbackup@$##Remove backup##$@vmbackup@$##'),
                modal: true,
                modalOverlayClose: false,
                width: 400,
                height: 200,
                contentURL: '/apps/vmbackup/remove_backup_confirm.html?v=6.0.8'
              });
              RemoveBackupWindow.callBack = function() {
                vmbackupLoadingShow();
                vmbackup_backup_remove(hostVminfo, that.data('backupinfo')).then(function(res) {
                  vmbackupLoadVMDetail(hostVminfo);
                })
              };
            });

            trdom.find('.revert').on('click', function() {
              var that = jQuery(this);
              var vmbackuprestoreWindow = new MUI.Modal({
                id: 'jv-vmbackuprestoreWindow',
                title: UNAS._('##$@vmbackup@$##Restore backup##$@vmbackup@$##'),
                modal: true,
                modalOverlayClose: false,
                width: 400,
                height: 260,
                contentURL: '/apps/vmbackup/restore_backup_confirm.html?v=6.0.8'
              });
              vmbackuprestoreWindow.callBack = function() {
                vmbackupLoadingShow();
                vmbackup_backup_restore(hostVminfo, that.data('backupinfo')).then(function(res) {
                  vmbackupLoadVMDetail(hostVminfo);
                  vmbackup_progress();
                })
              };
            });

            trdom.find('.restore').on('click', function() {
              var that = jQuery(this);
              restoreToNewVM(hostVminfo, that.data('backupinfo'));
            });

            trdom.find('.level').html("##$@vmbackup@$##" + joblevel[info.level] + "##$@vmbackup@$##");

            trdom.find('.status').show().html('<span>##$@vmbackup@$##' + jobstatus[info.jobstatus] + '##$@vmbackup@$##</span>');
            error_list = ['E', 'e', 'f'];
            if (error_list.includes(info.jobstatus)) {
              trdom.find('.status').addClass('jobError');
            }

            trdom.find('.action').show().html('<span>##$@vmbackup@$##' + jobType[info.type] + '##$@vmbackup@$##</span>');

            switch (info.jobstatus) {
              case 'T': //已完成
                trdom.find('.progressBar').hide();

                break;
              case 'C': //排队中
                is_running = 1;

                break;
              case 'R': //运行中
                is_running = 1;
                trdom.find('.speed').text(UNAS.getReadableSizeString(info.progress.speed || 0) + '/s');
                trdom.find('.size').text(UNAS.getReadableSizeString(info.progress.size || 0));

                break;
              case 'f': //失败
                trdom.find('.progressBar').hide();


                break;
              case 'A': //取消

                break;
              default:
            }

          }
          var vmbackupDomList = jQuery('#jv-vmbackupfolderhost').find('.jvc-unas_table_content').children();
          if (is_running) {
            vmbackup_Running = setTimeout(function() {
              vmbackupLoadVMDetail(hostVminfo);
            }, 3000);

          } else {
            clearTimeout(vmbackup_Running);
            vmbackupDomList.each(function(i, e) {
              var backupinfo = jQuery(e).data('backupinfo');
              if (backupinfo.jobstatus == 'T' && backupinfo.type == 'B') {
                jQuery(e).find('.revert,.restore').removeClass('nextbtndisabled');
              } else {
                jQuery(e).find('.revert,.restore').addClass('nextbtndisabled');
              }
            });

          }

        }
        resolve(data);
        vmbackupTranslator('jv-vmbackupfolderhost');
      },
      error: function(XMLHttpRequest, textStatus, errorThrown) {
        alert(textStatus);
      },
      complete: function(xhr, status) {
        vmbackupLoadingHide();
      }
    });
  })

}

//获取备份计划列表
function vmbackup_plan_alload() {
  vmbackupLoadingShow();
  return new Promise(function(resolve, reject) {
    jQuery.ajax({
      url: '/apps/vmbackup/includes/index.php',
      type: 'POST',
      data: JSON.encode({
        cmd: 'vmbackup_plan_alload',
        token: UToken,
      }),
      dataType: 'json',
      contentType: 'application/json',
      success: function(data) {
        resolve(data);
        if (data.err == 0) {
          jQuery('#jv-backupplanhost').empty();
          if (typeof(data.results.records) !== "undefined") {
            var planlist = data.results.records;
            for (i in planlist) {
              if (planlist.hasOwnProperty(i)) {
                var planinfo = planlist[i];
                planinfo.id = i;
                var plandom = vmbackupTemplateAppend(jQuery('#jv-backupplanhost'), 'jvt-plantr', 'jvt-plantr-' + i);
                plandom.find('.plan-host').text(planinfo.host + ":" + planinfo.port);
                plandom.find('.plan-vmname').text(planinfo.vm);
                plandom.find('.plan-caption').text(planinfo.caption);
                var hour = planinfo.hours[0];
                var minute = planinfo.minutes[0];
                var plantime = hour + ' <span>##$@vmbackup@$##hour##$@vmbackup@$##</span> ' + minute + ' <span>##$@vmbackup@$##minute##$@vmbackup@$##</span>';

                if (planinfo.weeks.length) {
                  if (planinfo.weeks.length == 7) {
                    plandom.find('.plan-time').html('<span>##$@vmbackup@$##Every day##$@vmbackup@$##<span> ' + '( ' + plantime + ' )');
                  } else {
                    var weekArray = new Array('Sunday', 'Monday', 'Tuesday', 'Wednesday', 'Thursday', 'Friday', 'Saturday');
                    var s = '';
                    for (var j = 0; j < planinfo.weeks.length; j++) {
                      s += ('<span>' + UNAS._(weekArray[planinfo.weeks[j]]) + '</span>');
                    }

                    plandom.find('.plan-time').html('<span>##$@vmbackup@$##weekly##$@vmbackup@$##<span>: ' + s + ' ( ' + plantime + ' )');
                  }
                } else if (planinfo.days.length) {
                  var day = '<span>##$@vmbackup@$##No.##$@vmbackup@$##<span> ' + planinfo.days[0] + ' <span>##$@vmbackup@$##day##$@vmbackup@$##</span>';
                  plandom.find('.plan-time').html('<span>##$@vmbackup@$##monthly##$@vmbackup@$##<span>: ' + day + ' ( ' + plantime + ' )');
                } else {

                }

                plandom.find('.delete').data('planinfo', planinfo);
                plandom.find('.delete').on('click', function() {
                  var that = jQuery(this);
                  var RemoveBackupPlanWindow = new MUI.Modal({
                    id: 'jv-RemoveBackupPlanWindow',
                    title: UNAS._('##$@vmbackup@$##Remove backup plan##$@vmbackup@$##'),
                    modal: true,
                    modalOverlayClose: false,
                    width: 400,
                    height: 200,
                    contentURL: '/apps/vmbackup/remove_backup_plan_confirm.html?v=6.0.8'
                  });
                  RemoveBackupPlanWindow.callBack = function() {
                    vmbackup_plan_remove(that.data('planinfo')).then(function() {
                      vmbackup_plan_alload();
                    })
                  };
                });
              }
            }



          }

          vmbackupTranslator('jv-backupplanhost');
        }
      },
      error: function(XMLHttpRequest, textStatus, errorThrown) {
        alert(textStatus);
      },
      complete: function(xhr, status) {
        vmbackupLoadingHide();
      }
    });
  })
}

//删除备份计划
function vmbackup_plan_remove(planinfo) {
  return new Promise(function(resolve, reject) {
    jQuery.ajax({
      url: '/apps/vmbackup/includes/index.php',
      type: 'POST',
      data: JSON.encode({
        cmd: 'vmbackup_plan_remove',
        token: UToken,
        params: {
          id: planinfo.id
        }
      }),
      dataType: 'json',
      contentType: 'application/json',
      success: function(data) {
        resolve(data);
      },
      error: function(XMLHttpRequest, textStatus, errorThrown) {
        alert(textStatus);
      },
      complete: function(xhr, status) {
        vmbackupLoadingHide();
      }
    });
  })
}

// 删除备份
function vmbackup_backup_remove(hostVminfo, backupinfo) {
  return new Promise(function(resolve, reject) {
    jQuery.ajax({
      url: '/apps/vmbackup/includes/index.php',
      type: 'POST',
      data: JSON.encode({
        cmd: 'vmbackup_vm_cbt_rm_job',
        token: UToken,
        params: {
          // clean: jQuery('#jv-isdeletediskbackup').prop('checked') ? 1 : 0,
          jobid: backupinfo.jobid,
          hstno: hostVminfo.hstno,
          vm: hostVminfo.vm
        }
      }),
      dataType: 'json',
      contentType: 'application/json',
      success: function(data) {
        resolve(data);
      },
      error: function(XMLHttpRequest, textStatus, errorThrown) {
        alert(textStatus);
      },
      complete: function(xhr, status) {
        vmbackupLoadingHide();
      }
    });
  })
}

//还原备份
function vmbackup_backup_restore(hostVminfo, backupinfo) {
  var power = +jQuery('#jv-backup-restore').prop('checked');
  return new Promise(function(resolve, reject) {
    jQuery.ajax({
      url: '/apps/vmbackup/includes/index.php',
      type: 'POST',
      data: JSON.encode({
        cmd: 'vmbackup_vm_cbt_restore',
        token: UToken,
        params: {
          jobid: backupinfo.jobid,
          power: power,
          mode: 1,
          hstno: +hostVminfo.hstno,
          vm: hostVminfo.vm
        }
      }),
      dataType: 'json',
      contentType: 'application/json',
      success: function(data) {
        resolve(data);
      },
      error: function(XMLHttpRequest, textStatus, errorThrown) {
        alert(textStatus);
      },
      complete: function(xhr, status) {
        vmbackupLoadingHide();
      }
    });
  })
}

// 备份进度
function vmbackup_progress() {
  //action 1.备份， 2.还原
  // 11: 等待其它任务结束后开始
  // 25: 准备中
  // 51: 正在生成备份文件
  // 63: 下载中
  // 64: 上传中
  // 94: 失败终止
  // 99: 完成(成功)
  var curhostinfo = jQuery('#jv-hostName').data('curhostinfo');
  jQuery.ajax({
    url: '/apps/vmbackup/includes/index.php',
    type: 'POST',
    data: JSON.encode({
      cmd: 'vmbackup_progress',
      token: UToken,
    }),
    dataType: 'json',
    contentType: 'application/json',
    success: function(data) {
      if (data.err == 0) {
        var progressinfo = data.results;
        var vmbackupDomList = jQuery('#jv-vmbackupfolderhost').find('.jvc-unas_table_content').children();
        if (progressinfo) {
          vmbackup_progress_time = setTimeout(function() {
            vmbackup_progress();
          }, 3000);
          vmbackupDomList.each(function(i, e) {
            jQuery(e).find('.revert,.restore').addClass('nextbtndisabled');
          });
        } else {
          clearTimeout(vmbackup_progress_time);
        }

      } else {

      }
    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      alert(textStatus);
    },
    complete: function(xhr, status) {
      vmbackupLoadingHide();
    }
  });
}

// add Vm host
function vmbackupAddVMHost(data) {
  var title = UNAS._('##$@vmbackup@$##Add Host##$@vmbackup@$##');
  if (data) {
    title = UNAS._('##$@vmbackup@$##Connect Host##$@vmbackup@$##');
  }
  var vmbackupAddVMHostWindow = new MUI.Modal({
    id: 'vmbackupAddVMHostWindow',
    title: title,
    modal: true,
    modalOverlayClose: false,
    width: 600,
    height: 400,
    data : data,
    contentURL: '/apps/vmbackup/add_vm_host.html?v=6.0.8'
  });
}

// add vCenter
function addvCenter() {
  var vCenterWindow = new MUI.Modal({
    id: 'jv-vCenterWindow',
    title: UNAS._('##$@vmbackup@$##Add vCenter##$@vmbackup@$##'),
    modal: true,
    modalOverlayClose: false,
    width: 600,
    height: 400,
    contentURL: '/apps/vmbackup/addvcenter.html?v=6.0.8'
  });
}

//remove Host
function removeHost() {
  var e = window.event || arguments.callee.caller.arguments[0];
  var hostinfo = jQuery(e.target).data('hostinfo');
  if (!hostinfo) {
    return;
  }

  var RemoveHostWindow = new MUI.Modal({
    id: 'jv-RemoveHostWindow',
    title: UNAS._('##$@vmbackup@$##Remove Host##$@vmbackup@$##'),
    modal: true,
    modalOverlayClose: false,
    width: 400,
    height: 200,
    contentURL: '/apps/vmbackup/remove_host_confirm.html?v=6.0.8'
  });
  RemoveHostWindow.callBack = function() {
    return new Promise(function(resolve, reject) {
      jQuery.ajax({
        url: '/apps/vmbackup/includes/index.php',
        type: 'POST',
        data: JSON.encode({
          cmd: 'vmbackup_host_remove',
          token: UToken,
          params: {
            clean: jQuery('#jv-isdeletediskbackup').prop('checked') ? 1 : 0,
            hstno: +hostinfo.hstno
          }
        }),
        dataType: 'json',
        contentType: 'application/json',
        success: function(data) {
          if (data.err == 0) {
            resolve(data);
          }
        },
        error: function(XMLHttpRequest, textStatus, errorThrown) {
          alert(textStatus);
        },
        complete: function(xhr, status) {}
      });
    }).then(function(res) {
      vmbackupLoadHosts().then(function(res) {
        jQuery('#jv-vmHost .vmHostitem').eq(0).find('.ipinfo').click();
      });
    })
  };
}
// Delete Vm

// 手动创建备份
function vmbackup_backup_create(hostinfo, hostvminfo) {
  return new Promise(function(resolve, reject) {
    jQuery.ajax({
      url: '/apps/vmbackup/includes/index.php',
      type: 'POST',
      data: JSON.encode({
        cmd: 'vmbackup_vm_cbt_create',
        token: UToken,
        params: {
          hstno: +hostinfo.hstno,
          host: hostinfo.host,
          port: +hostinfo.port,
          vmname: hostvminfo.vmname,
          level: jQuery('#jv-fullbackup').prop('checked') ? "Full" : "Incremental"
        }
      }),
      dataType: 'json',
      contentType: 'application/json',
      success: function(data) {
        if (data.err == 0) {}
        resolve(data);
      },
      error: function(XMLHttpRequest, textStatus, errorThrown) {
        alert(textStatus);
      },
      complete: function(xhr, status) {
        vmbackupLoadingHide();
      }
    });
  });
}
//日志
function vmbackup_log_loadby(p) {
  vmbackupLoadingShow();
  jQuery.ajax({
    url: '/apps/vmbackup/includes/index.php',
    type: 'POST',
    data: JSON.encode({
      cmd: 'vmbackup_log_loadby',
      token: UToken,
      params: {
        page: p.index,
        ofpage: p.amount
      }
    }),
    dataType: 'json',
    contentType: 'application/json',
    success: function(data) {
      // console.log(data);
      if (data.err == 0) {
        jQuery('#jv-backuploghost').empty();
        jQuery('#jv-backuplogallcheckd').prop('checked', false);
        jQuery('#jv-removelogbtn').attr('class', 'unas_button_sub_disabled');
        var records = data.results.records || [];
        vmbackupLogPage.pageCount = Math.ceil(data.results.reccount / vmbackupLogPage.amount);
        if (vmbackupLogPage.pageCount <= 1) {
          jQuery('#jv-nextbtn').hide();
        } else {
          jQuery('#jv-nextbtn').show();
        }
        if (p.index == vmbackupLogPage.pageCount) {
          jQuery('.nextpage').addClass('nextbtndisabled');
        } else {
          jQuery('.nextpage').removeClass('nextbtndisabled');
        }

        if (p.index == 1) {
          jQuery('.prevpage').addClass('nextbtndisabled');
        } else {
          jQuery('.prevpage').removeClass('nextbtndisabled');
        }

        if (records.length) {
          for (var i = 0; i < records.length; i++) {
            var loginfo = records[i];
            var logtrdom = vmbackupTemplateAppend(jQuery('#jv-backuploghost'), 'jvt-logtr', 'jvt-logtr-' + i);
            logtrdom.find('label').attr('for', 'log_checkdselect-' + i);
            logtrdom.find('input').attr('id', 'log_checkdselect-' + i).data('loginfo', loginfo).on('click', function(e) {
              var target = e.currentTarget;
              var k = 0;
              jQuery('#jv-backuploghost').children().each(function(i, ce) {
                if (jQuery(ce).find('input[type=checkbox]').prop('checked')) {
                  k++;
                }
              })
              if (k) {
                jQuery('#jv-removelogbtn').attr('class', 'unas_button_sub');
              } else {
                jQuery('#jv-removelogbtn').attr('class', 'unas_button_sub_disabled');
              }

              if (jQuery('#jv-backuploghost').children().length == k) {
                jQuery('#jv-backuplogallcheckd').prop('checked', true);
              } else {
                jQuery('#jv-backuplogallcheckd').prop('checked', false);
              }

            });
            logtrdom.find('.log-host').text(loginfo.address);
            logtrdom.find('.log-vmname').text(loginfo.vmname);
            logtrdom.find('.log-reason').text(loginfo.reason);
            logtrdom.find('.log-time').text(loginfo.time);
            if (loginfo.content) {
              var content = loginfo.content.split(":");
              var s = '<span>' + content + '</span>';
              if (content[1]) {
                s += ":" + '<span>' + content[1] + '</span>';
              }

              logtrdom.find('.log-des').html(s);
            }

          }
          vmbackupTranslator('jv-backuploghost');

        } else {

        }
      }
    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      alert(textStatus);
    },
    complete: function(xhr, status) {
      vmbackupLoadingHide();
    }
  });
}

//上一页
function prevpage() {
  vmbackupLogPage.index--;
  if (vmbackupLogPage.index < 1) {
    vmbackupLogPage.index = 1;
    return;
  }
  vmbackup_log_loadby(vmbackupLogPage);
}

//下一页
function lognextpage() {
  vmbackupLogPage.index++;
  if (vmbackupLogPage.index > vmbackupLogPage.pageCount) {
    vmbackupLogPage.index = vmbackupLogPage.pageCount;
    return;
  } else {
    vmbackup_log_loadby(vmbackupLogPage);
  }
}

// 删除日志
function vmbackup_log_remove() {
  var lognos = [];
  jQuery('#jv-backuploghost').children().each(function(i, e) {
    if (jQuery(e).find('input[type=checkbox]').prop('checked')) {
      logno = +jQuery(e).find('input[type=checkbox]').data('loginfo').logno;
      lognos.push(logno);
    }
  })
  if (!lognos.length) {
    return;
  }
  vmbackupLoadingShow();
  jQuery.ajax({
    url: '/apps/vmbackup/includes/index.php',
    type: 'POST',
    data: JSON.encode({
      cmd: 'vmbackup_log_remove',
      token: UToken,
      params: {
        lognos: lognos
      }
    }),
    dataType: 'json',
    contentType: 'application/json',
    success: function(data) {
      vmbackupLogPage.index = 1;
      vmbackup_log_loadby(vmbackupLogPage);
    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      alert(textStatus);
    },
    complete: function(xhr, status) {
      vmbackupLoadingHide();
    }
  });
}

//全选
function backuplogallcheckd() {
  var e = window.event || arguments.callee.caller.arguments[0];
  if (e.target.checked) {
    jQuery('#jv-backuploghost').children().each(function(i, e) {
      jQuery(e).find('input[type=checkbox]').prop('checked', true);
    })
    jQuery('#jv-removelogbtn').attr('class', 'unas_button_sub');
  } else {
    jQuery('#jv-backuploghost').children().each(function(i, e) {
      jQuery(e).find('input[type=checkbox]').prop('checked', false);
    })
    jQuery('#jv-removelogbtn').attr('class', 'unas_button_sub_disabled');
  }
}

//备份设置
function backupsettings(fn) {
  var backupsettingsWindow = new MUI.Modal({
    id: 'backupsettingsWindow',
    title: UNAS._('##$@vmbackup@$##Backup Setting##$@vmbackup@$##'),
    modal: true,
    modalOverlayClose: false,
    width: 900,
    height: 370,
    contentURL: '/apps/vmbackup/backupsettings.html?v=6.0.8'
  });
  backupsettingsWindow.callBack = function() {
    if (typeof fn == 'function') {
      fn();
    }
  };
}

//
function vmbackupplan(vminfo) {
  var hostinfo = jQuery('#jv-removeHost').data('hostinfo');
  var vmbackupplanWindow = new MUI.Modal({
    id: 'vmbackupplanWindow',
    title: UNAS._('##$@vmbackup@$##Backup Plan##$@vmbackup@$##'),
    modal: true,
    modalOverlayClose: false,
    width: 500,
    height: 250,
    contentURL: '/apps/vmbackup/vmbackupplan.html?v=6.0.8&vmname=' + vminfo.vmname + '&hstno=' + hostinfo.hstno
  });
  vmbackupplanWindow.callBack = function() {
    vmbackup_plan_alload();
  };

}

(function() {
  vmbackupLoadHosts().then(function(res) {
    // jQuery('#jv-vmHost .vmHostitem').eq(0).find('.ipinfo').click();
  });

  jQuery('#vmbackup_page div[unastabtype]').each(function(i, e) {
    e.onclick = function() {
      jQuery('#vmbackup_page div[unastabtype]').attr('class', 'unas_tab');
      jQuery(this).attr('class', 'unas_tab_sel');
      jQuery(this).siblings('div[unastabtype]').each(function(k, ce) {
        jQuery('#jv-' + jQuery(ce).attr('unastabtype')).attr('style', 'display:none;');
      })
      var id = jQuery(this).attr('unastabtype');
      jQuery('#jv-' + id).attr('style', 'display:block');

      if (id == "backuplog") {
        vmbackup_log_loadby(vmbackupLogPage);
      }
    }
  })
  vmbackup_plan_alload();
})();
